from cc3d import CompuCellSetup
from cc3d.core.PySteppables import *
from cc3d.cpp.PlayerPython import * 
import random
from random import random
from random import uniform
from random import seed
import numpy as np
import math

seed(1)

#Phase synchronization by relative cell location (see in Contact Plugin in xml file)

#Define parameters
K=0.6667
omega = 0.001

sin_phase_dif_sum_list = []



class cellsort_2DSteppable(SteppableBasePy):

    def __init__(self,frequency=1):

        SteppableBasePy.__init__(self,frequency)
        self.cellclock=self.createScalarFieldCellLevelPy("CellClock")
        
        #Color for different valued internal clocks
        self.track_cell_level_scalar_attribute(field_name='SIN_CLOCK', attribute_name='internalclock')
        
        self.track_cell_level_scalar_attribute(field_name='Phase_Difference_Sin', attribute_name='internalclockdifference')
        
    def start(self):
        """
        any code in the start function runs before MCS=0
        """
        for cell in self.cellList:             #This does not include the medium
                
            self.cellclock[cell]=uniform(0,2*math.pi)
            cell.dict['internalclock'] = math.sin(self.cellclock[cell])
            
            self.adhesionFlexPlugin.setAdhesionMoleculeDensity(cell, "ClockPhase", self.cellclock[cell])  
            cell.dict['cellclockOLD'] = self.cellclock[cell]

            
            # if cell.id==1:
                # self.cellclock[cell]=0
            # if cell.id==2:
               # self.cellclock[cell]=0.0001 
            # cell.dict['internalclock'] = math.sin(self.cellclock[cell])
            # cell.dict['internalclockdifference']= math.sin(self.cellclock[cell])
                
                
                
        #figure out how to change medium color in tracker field below
        #how does cc3d handle fvalues outside the fixed values
        # if cell.type==0:
            # ecm=cell
            # ecm.dict['internalclock'] = -1
            
       # #Debugging test plot: Start with same clock phases
        # self.plot_win3 = self.add_new_plot_window(title='PHASE DIFFERENCE',
                                                # x_axis_title='MonteCarlo Step (MCS)',
                                                # y_axis_title='Clock (sin of)', x_scale_type='linear', y_scale_type='linear',
                                                # grid=False)
        # self.plot_win3.add_plot("Cell #1", style='Lines', color='red', size=1)
        #self.plot_win3.add_plot("Cell #2", style='Lines', color='green', size=1)
            
        ##Plot to track individual cell clocks      
        #self.plot_win = self.add_new_plot_window(title='Cell clocks',
        #                                         x_axis_title='MonteCarlo Step (MCS)',
        #                                         y_axis_title='Clock', x_scale_type='linear', y_scale_type='linear',
        #                                         grid=False)       
        #self.plot_win.add_plot("Cell #20", style='Dots', color='red', size=1)
        #self.plot_win.add_plot("Cell #21", style='Dots', color='blue', size=1)
        #self.plot_win.add_plot("Cell #22", style='Dots', color='green', size=1)
        
        # self.plot_win1 = self.add_new_plot_window(title='Sine of Phase Differences for cells 134 and 135',
                                                # x_axis_title='MonteCarlo Step (MCS)',
                                                # y_axis_title='Clock', x_scale_type='linear', y_scale_type='linear',
                                                # grid=False)       
        # self.plot_win1.add_plot("Cell 134", style='Lines', color='red', size=1)
        # self.plot_win1.add_plot("Cell 135", style='Lines', color='blue', size=1)        
         
         
        # self.plot_win2 = self.add_new_plot_window(title='Phase difference mod 2pi for cells 134, 135',
                                                # x_axis_title='MonteCarlo Step (MCS)',
                                                # y_axis_title='Clock', x_scale_type='linear', y_scale_type='linear',
                                                # grid=False)       
        # self.plot_win2.add_plot("Cell 134", style='Lines', color='red', size=1)
        # self.plot_win2.add_plot("Cell 135", style='Lines', color='blue', size=1)        
        
        #Making a plot over all cells
        # self.plot_win3 = self.add_new_plot_window(title='ALL CELLS: sin(phase difference)',
                                                # x_axis_title='MonteCarlo Step (MCS)',
                                                # y_axis_title='Clock', x_scale_type='linear', y_scale_type='linear',
                                                # grid=False)   
        # for x in range(1,446):
            # character_name="Cell"+str(x)
            # self.plot_win3.add_plot(character_name, style='Lines', color='red', size=1)
      
       
    def step(self,mcs): 
        """
        """
        for cell in self.cellList:

            neighbor_list = self.get_cell_neighbor_data_list(cell)

            for neighbor, common_surface_area in neighbor_list:
                if neighbor:
                    sin_phase_dif_sum_list.append(math.sin(neighbor.dict['cellclockOLD']-cell.dict['cellclockOLD']))
                
            #for when cells do not have neighbors and we cannot divide by zero
            if (len(sin_phase_dif_sum_list)==0):
                s=1
            else:
                s=len(sin_phase_dif_sum_list)            
                
            summed_sin_clock_change = sum(sin_phase_dif_sum_list)
            self.cellclock[cell]=(cell.dict['cellclockOLD'])+(omega*(K)*(1/s)*summed_sin_clock_change)
            
            sin_phase_dif_sum_list.clear()
          
        #update clocks, adhesion
        for cell in self.cellList:
            cell.dict['cellclockOLD'] = self.cellclock[cell]
            self.adhesionFlexPlugin.setAdhesionMoleculeDensity(cell, "ClockPhase", self.cellclock[cell])
            cell.dict['internalclock'] = math.sin(self.cellclock[cell])
            cell.dict['internalclockdifference'] = math.sin((self.cellclock[cell]) - (omega*mcs))            
            
        
        #for cell in self.cellList:
        #    if cell.id==20:
        #        print("cell.id=",cell.id)
        #        print("self.cellclock[cell]=",self.cellclock[cell])   
        
        #PLOTS
        # if (mcs % 100) == 0:
            
                    # ##Debugging Test: Start with same clock phases
        # ## arguments are (name of the data series, x, y)
            # self.plot_win3.add_data_point("Cell #1", mcs, self.cellclock[self.attemptFetchingCellById(1)]-self.cellclock[self.attemptFetchingCellById(2)])
            #self.plot_win3.add_data_point("Cell #2", mcs, math.sin(self.cellclock[self.attemptFetchingCellById(2)]))
            
        # ## arguments are (name of the data series, x, y)
        # #self.plot_win.add_data_point("Cell #20", mcs, self.cellclock[self.attemptFetchingCellById(20)])
        # #self.plot_win.add_data_point("Cell #21", mcs, self.cellclock[self.attemptFetchingCellById(21)])
        # #self.plot_win.add_data_point("Cell #22", mcs, self.cellclock[self.attemptFetchingCellById(22)])
        
            # # self.plot_win1.add_data_point("Cell 134", mcs, math.sin(self.cellclock[self.attemptFetchingCellById(134)]-omega*mcs))
            # # self.plot_win1.add_data_point("Cell 135", mcs, math.sin(self.cellclock[self.attemptFetchingCellById(135)]-omega*mcs))        
                 
            # # self.plot_win2.add_data_point("Cell 134", mcs, ((self.cellclock[self.attemptFetchingCellById(134)]-omega*mcs)%(2*math.pi)))
            # # self.plot_win2.add_data_point("Cell 135", mcs, ((self.cellclock[self.attemptFetchingCellById(135)]-omega*mcs)%(2*math.pi)))                
     
            # for x in range(1,446):
                # character_name="Cell"+str(x)
                # self.plot_win3.add_data_point(character_name, mcs, math.sin(self.cellclock[self.attemptFetchingCellById(x)]-omega*mcs))
                
     
    def finish(self):
        """
        Finish Function is called after the last MCS
        """





